%global    gem_name    rspec-core

%bcond_with bootstrap
%bcond_with aruba

%undefine __brp_mangle_shebangs

Summary:    RSpec runner and formatters
Name:       rubygem-%{gem_name}
Version:    3.12.1
Release:    5%{?dist}
License:    MIT
URL:        http://github.com/rspec/rspec-core
Source0:    http://rubygems.org/gems/%{gem_name}-%{version}.gem
Source1:    https://github.com/rspec/%{gem_name}/archive/v%{version}.tar.gz

Patch3000:  rubygem-rspec-core-3.10.1-Filter-content-of-usr-share-ruby.patch

BuildRequires:    rubygems-devel
%if %{without bootstrap}
BuildRequires:    rubygem(minitest) rubygem(rake) rubygem(rspec) rubygem(test-unit) rubygem(coderay)
BuildRequires:    rubygem(thread_order) git glibc-langpack-en

%if %{with aruba}
BuildRequires:    rubygem(aruba) rubygem(flexmock) rubygem(mocha) rubygem(rr) rubygem(cucumber)
%endif
%endif
Requires:    rubygem(rake)
BuildArch:   noarch

%description
Behaviour Driven Development for Ruby. RSpec runner and example groups.

%prep
%setup -q -T -n %{gem_name}-%{version} -b 1
%patch3000 -p1
gem specification %{SOURCE0} -l --ruby > %{gem_name}.gemspec

%build
gem build %{gem_name}.gemspec
%gem_install

%install
mkdir -p %{buildroot}%{_prefix}
cp -a .%{_prefix}/* %{buildroot}%{_prefix}/

rm -f %{buildroot}%{gem_instdir}/{.document,.yardopts}

%check
%if %{without bootstrap}
LANG=C.UTF-8

%if %{without aruba}
truncate -s 0 spec/support/aruba_support.rb
find spec/integration -exec truncate -s 0 {} \;
%endif

sed -i '/backtrace_exclusion_patterns/ s/rspec-core/rspec-core-%{version}/' \
  spec/integration/{suite_hooks_errors,spec_file_load_errors}_spec.rb

sed -i spec/integration/spec_file_load_errors_spec.rb \
    -e '\@nicely handles load-time errors in user spec files@s| it | xit |'

sed -i spec/rspec/core/example_spec.rb \
    -e '\@defined.*RUBY_ENGINE.*truffleruby@s|^\(.*\)$|\1 \&\& false|'

ruby -Ilib -S exe/rspec --seed 1 #33413

%if %{with aruba}
sed -i features/command_line/init.feature \
       -e 's|^\([ \t]*\)\(Scenario: Accept and use the recommended settings\)|\1@broken\n\1\2|'

for f in  \
    `# disabling tests failing with rr 1.2.1` \
    `# https://github.com/rspec/rspec-core/issues/2882` \
    features/mock_framework_integration/use_rr.feature \
    %{nil}
do
    mv $f ${f}.drop
done

sed -i cucumber.yml -e 's|~@wip|"not @wip"|'
sed -i features/support/require_expect_syntax_in_aruba_specs.rb -e 's|~@|not @|g'
sed -i features/support/diff_lcs_versions.rb -e 's|scenario.title|scenario.name|'

export RUBYOPT="-I$(pwd)/lib:$(ruby -e 'puts %w[rspec/support minitest test/unit].map {|r| Gem::Specification.find_by_path(r).full_require_paths}.join(?:)')"
export CUCUMBER_PUBLISH_QUIET=true
cucumber -v -f progress features/ || \
    cucumber -v -f progress features/ \
    --tag "not @broken" \
    `# Explicitly skip 'skip-when-diff-lcs-1.3' and '@ruby-2-7' test cases. While` \
    `# the conditions are correctly detected, the 'warning' called instead their` \
    `# execution is troublesome, possibly due to upstream using old Cucumber?` \
    --tag "not @skip-when-diff-lcs-1.3" \
    --tag "not @ruby-2-7" \
    %{nil}

for f in  \
    features/mock_framework_integration/use_rr.feature \
    %{nil}
do
    mv ${f}.drop ${f}
done
%endif
%endif

%files
%license    %{gem_instdir}/LICENSE.md
%doc    %{gem_instdir}/Changelog.md
%doc    %{gem_instdir}/README.md
%{gem_docdir}
%{_bindir}/rspec
%{gem_instdir}/exe/
%{gem_instdir}/lib/
%{gem_spec}
%exclude    %{gem_cache}

%changelog
* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.12.1-5
- Rebuilt for OpenCloudOS Stream 23.09

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.12.1-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.12.1-3
- Rebuilt for OpenCloudOS Stream 23

* Tue Mar 21 2023 Shuo Wang <abushwang@tencent.com> - 3.12.1-2
- close bootstrap

* Mon Mar 20 2023 Shuo Wang <abushwang@tencent.com> - 3.12.1-1
- initial build
